//***********************************************************************
//
//  Paint6View.h
//
//***********************************************************************

class CPaintView : public CScrollView
{
    DECLARE_DYNCREATE (CPaintView)

private:
    CPoint m_ptFrom;
    CPoint m_ptTo;

    CPaintDoc* GetDocument () { return (CPaintDoc*) m_pDocument; }
    void InvertLine (CDC*, CPoint, CPoint);

public:
    virtual void OnInitialUpdate ();

protected:
    virtual void OnDraw (CDC*);
    virtual void OnUpdate (CView*, LPARAM, CObject*);

    afx_msg void OnLButtonDown (UINT, CPoint);
    afx_msg void OnMouseMove (UINT, CPoint);
    afx_msg void OnLButtonUp (UINT, CPoint);
    afx_msg void OnContextMenu (CWnd*, CPoint);

    DECLARE_MESSAGE_MAP ()
};
